#include "CH57x_common.h"
#include "stdlib.h"
#include "font.h"

#define CS0    GPIOB_ResetBits( GPIO_Pin_12 )
#define CS1    GPIOB_SetBits( GPIO_Pin_12 )

#define CLK0    GPIOB_ResetBits( GPIO_Pin_23 )
#define CLK1    GPIOB_SetBits( GPIO_Pin_23 )
#define RCK0    GPIOA_ResetBits( GPIO_Pin_8 )
#define RCK1    GPIOA_SetBits( GPIO_Pin_8 )
#define DA0     GPIOA_ResetBits( GPIO_Pin_10 )
#define DA1     GPIOA_SetBits( GPIO_Pin_10 )

#define KA      GPIOA_ReadPortPin( GPIO_Pin_12 )
#define KB      GPIOA_ReadPortPin( GPIO_Pin_11 )
#define JTB      GPIOB_ReadPortPin( GPIO_Pin_15 )

__attribute__((aligned(4)))   UINT8 spibuf[320];

UINT8V ss=0,ss2=0;
UINT8 DO=0,m=0,m2=0,m20=0,m0=255,mi=0,medit=0,pshow=0;
UINT8V kdir=0,kstep=0,kdelay=0,key=0;    //ת
UINT16V kstate=0;

char sbuf[128],slen=0;
UINT8V rin1=0;
UINT8 rbuf1[128];
UINT16 ad[5],v[10]={0,},mset[20]={0,},rs485_buf[20];

char mt[20][20];
char *tt[]={"","","","¼","","ѧϰ","","",
        "VF1:","VF2:","IF1:","IF2:","Time:",
};

void mysend(void) {
  UART1_SendString(sbuf, slen );
}

void UART_init(void) {
  // ô1
  GPIOB_SetBits( GPIO_Pin_4 );
  GPIOB_ModeCfg( GPIO_Pin_7, GPIO_ModeIN_PU );      // RXD-
  GPIOB_ModeCfg( GPIO_Pin_4, GPIO_ModeOut_PP_5mA );    // TXD-עIOߵƽ
  UART1_BaudRateCfg(9600);
  UART1_DefInit();

  UART1_ByteTrigCfg( UART_1BYTE_TRIG );
  UART1_INTCfg( ENABLE, RB_IER_RECV_RDY );
  PFIC_EnableIRQ( UART1_IRQn );
}

void saveini(void) {
  // Data-Flash
  FLASH_ROM_LOCK(0);
  EEPROM_ERASE( 0, EEPROM_BLOCK_SIZE );
  /*
  UINT8 i,tmp[3];

  EEPROM_WRITE( 0, id, 13);
  EEPROM_WRITE( 13, host, 41);
  EEPROM_WRITE( 54, url, 41);
  for (i=0;i<10;i++) {
      tmp[0]=lset[i]>>8;
      tmp[1]=lset[i]&0xff;
      EEPROM_WRITE( 96+i*2, tmp, 2);
  }
   */
}

void loadini(void) {
  /*
  UINT8 i,tmp[3];

  EEPROM_READ( 0, id, 13 );
  EEPROM_READ( 13, host, 41 );
  EEPROM_READ( 54, url, 41 );
  for (i=0;i<10;i++) {
      EEPROM_READ( 96+i*2, tmp, 2 );
      lset[i]=(tmp[0]<<8)|tmp[1];
  }
   */
}

//HC595
__attribute__((section(".highcode")))
void rushdo(void)   {
   UINT8 i;
   for (i=0;i<8;i++)   {
       if (DO&(1<<(7-i)))  DA1; else DA0;
       CLK0;
       CLK1;
   }
   RCK1;
   RCK0;
}

void LCD_WR_DATA8(UINT8 dat)
{
    CS0;
    SPI0_MasterSendByte(dat);
    CS1;
}

void LCD_WR_DATA(UINT16 dat)
{
    spibuf[0]=dat>>8;
    spibuf[1]=dat;

    CS0;
    //SPI0_MasterSendByte(dat>>8);
    //SPI0_MasterSendByte(dat);
    SPI0_MasterTrans( spibuf, 2 );
    CS1;
}

__attribute__((section(".highcode")))
void LCD_WR_DATA0(UINT16 dat)
{
    spibuf[0]=dat>>8;
    spibuf[1]=dat;
    SPI0_MasterTrans( spibuf, 2 );

    //SPI0_MasterSendByte(dat>>8);
    //SPI0_MasterSendByte(dat);
}

void LCD_WR_REG(UINT8 dat)
{
    DO&=0xBf;rushdo();//д
    CS0;
    SPI0_MasterSendByte(dat);
    CS1;
    DO|=0X40;rushdo();//д
}

__attribute__((section(".highcode")))
void LCD_WR_REG0(UINT8 dat)
{
    DO&=0xBf;rushdo();//д
    SPI0_MasterSendByte(dat);
    DO|=0X40;rushdo();//д
}

void LCD_Address_Set(UINT16 x1,UINT16 y1,UINT16 x2,UINT16 y2)
{
    LCD_WR_REG(0x2a);//еַ
    LCD_WR_DATA(x1+1);
    LCD_WR_DATA(x2+1);
    LCD_WR_REG(0x2b);//еַ
    LCD_WR_DATA(y1+2);
    LCD_WR_DATA(y2+2);
    LCD_WR_REG(0x2c);//д
}

void LCD_Init(void)
{
    DO&=0X7F;rushdo();  //λ
    DelayMs(100);
    DO|=0X80;rushdo();
    DelayMs(100);

    //************* Start Initial Sequence **********//
    LCD_WR_REG(0x11); //Sleep out
    DelayMs(100);              //Delay 120ms
    //------------------------------------ST7735S Frame Rate-----------------------------------------//
    LCD_WR_REG(0xB1);
    LCD_WR_DATA8(0x05);
    LCD_WR_DATA8(0x3C);
    LCD_WR_DATA8(0x3C);
    LCD_WR_REG(0xB2);
    LCD_WR_DATA8(0x05);
    LCD_WR_DATA8(0x3C);
    LCD_WR_DATA8(0x3C);
    LCD_WR_REG(0xB3);
    LCD_WR_DATA8(0x05);
    LCD_WR_DATA8(0x3C);
    LCD_WR_DATA8(0x3C);
    LCD_WR_DATA8(0x05);
    LCD_WR_DATA8(0x3C);
    LCD_WR_DATA8(0x3C);
    //------------------------------------End ST7735S Frame Rate---------------------------------//
    LCD_WR_REG(0xB4); //Dot inversion
    LCD_WR_DATA8(0x03);
    //------------------------------------ST7735S Power Sequence---------------------------------//
    LCD_WR_REG(0xC0);
    LCD_WR_DATA8(0x28);
    LCD_WR_DATA8(0x08);
    LCD_WR_DATA8(0x04);
    LCD_WR_REG(0xC1);
    LCD_WR_DATA8(0XC0);
    LCD_WR_REG(0xC2);
    LCD_WR_DATA8(0x0D);
    LCD_WR_DATA8(0x00);
    LCD_WR_REG(0xC3);
    LCD_WR_DATA8(0x8D);
    LCD_WR_DATA8(0x2A);
    LCD_WR_REG(0xC4);
    LCD_WR_DATA8(0x8D);
    LCD_WR_DATA8(0xEE);
    //---------------------------------End ST7735S Power Sequence-------------------------------------//
    LCD_WR_REG(0xC5); //VCOM
    LCD_WR_DATA8(0x1A);
    LCD_WR_REG(0x36); //MX, MY, RGB mode
    LCD_WR_DATA8(0xA0);
    //------------------------------------ST7735S Gamma Sequence---------------------------------//
    LCD_WR_REG(0xE0);
    LCD_WR_DATA8(0x04);
    LCD_WR_DATA8(0x22);
    LCD_WR_DATA8(0x07);
    LCD_WR_DATA8(0x0A);
    LCD_WR_DATA8(0x2E);
    LCD_WR_DATA8(0x30);
    LCD_WR_DATA8(0x25);
    LCD_WR_DATA8(0x2A);
    LCD_WR_DATA8(0x28);
    LCD_WR_DATA8(0x26);
    LCD_WR_DATA8(0x2E);
    LCD_WR_DATA8(0x3A);
    LCD_WR_DATA8(0x00);
    LCD_WR_DATA8(0x01);
    LCD_WR_DATA8(0x03);
    LCD_WR_DATA8(0x13);
    LCD_WR_REG(0xE1);
    LCD_WR_DATA8(0x04);
    LCD_WR_DATA8(0x16);
    LCD_WR_DATA8(0x06);
    LCD_WR_DATA8(0x0D);
    LCD_WR_DATA8(0x2D);
    LCD_WR_DATA8(0x26);
    LCD_WR_DATA8(0x23);
    LCD_WR_DATA8(0x27);
    LCD_WR_DATA8(0x27);
    LCD_WR_DATA8(0x25);
    LCD_WR_DATA8(0x2D);
    LCD_WR_DATA8(0x3B);
    LCD_WR_DATA8(0x00);
    LCD_WR_DATA8(0x01);
    LCD_WR_DATA8(0x04);
    LCD_WR_DATA8(0x13);
    //------------------------------------End ST7735S Gamma Sequence-----------------------------//
    LCD_WR_REG(0x3A); //65k mode
    LCD_WR_DATA8(0x05);
    LCD_WR_REG(0x29); //Display on
}

void LCD_DrawPoint(UINT16 x,UINT16 y,UINT16 color)
{
    LCD_Address_Set(x,y,x,y);//ùλ
    LCD_WR_DATA(color);
}
__attribute__((section(".highcode")))
void LCD_DrawPoint0(UINT16 x,UINT16 y,UINT16 color)
{
    spibuf[0]=(x+1)>>8;
    spibuf[1]=(x+1);
    spibuf[2]=(x+1)>>8;
    spibuf[3]=(x+1);
    LCD_WR_REG0(0x2a);//еַ
    SPI0_MasterTrans( spibuf, 4 );
    //LCD_WR_DATA0(x+1);
    //LCD_WR_DATA0(x+1);
    spibuf[0]=(y+2)>>8;
    spibuf[1]=(y+2);
    spibuf[2]=(y+2)>>8;
    spibuf[3]=(y+2);
    LCD_WR_REG0(0x2b);//еַ
    SPI0_MasterTrans( spibuf, 4 );
    //LCD_WR_DATA0(y+2);
    //LCD_WR_DATA0(y+2);
    LCD_WR_REG0(0x2c);//д

    spibuf[0]=(color)>>8;
    spibuf[1]=(color);
    SPI0_MasterTrans( spibuf, 2 );
    //LCD_WR_DATA0(color);
}

void LCD_DrawLine(UINT16 x1,UINT16 y1,UINT16 x2,UINT16 y2,UINT16 color)
{
    UINT16 t;
    int xerr=0,yerr=0,delta_x,delta_y,distance;
    int incx,incy,uRow,uCol;
    delta_x=x2-x1; //
    delta_y=y2-y1;
    uRow=x1;//
    uCol=y1;
    if(delta_x>0)incx=1; //õ
    else if (delta_x==0)incx=0;//ֱ
    else {incx=-1;delta_x=-delta_x;}
    if(delta_y>0)incy=1;
    else if (delta_y==0)incy=0;//ˮƽ
    else {incy=-1;delta_y=-delta_y;}
    if(delta_x>delta_y)distance=delta_x; //ѡȡ
    else distance=delta_y;
    for(t=0;t<distance+1;t++)
    {
        LCD_DrawPoint(uRow,uCol,color);//
        xerr+=delta_x;
        yerr+=delta_y;
        if(xerr>distance)
        {
            xerr-=distance;
            uRow+=incx;
        }
        if(yerr>distance)
        {
            yerr-=distance;
            uCol+=incy;
        }
    }
}

__attribute__((section(".highcode")))
void LCD_Fill(UINT16 xsta,UINT16 ysta,UINT16 w,UINT16 h,UINT16 color)
{
    UINT8 i;
    //UINT16 num=w*h;

    //ch=color>>8;
    //cl=color;

    LCD_Address_Set(xsta,ysta,xsta+w-1,ysta+h-1);//ʾΧ
    DO|=0X40;rushdo();//д
    CS0;
    for (i=0;i<w;i++) {
        spibuf[i*2]=color>>8;
        spibuf[i*2+1]=color;
    }
    for(i=0;i<h;i++)    SPI0_MasterTrans( spibuf, w*2 );
    /*
    while(num){
        SPI0_MasterSendByte(ch);
        SPI0_MasterSendByte(cl);
        num--;
    }
     */
    CS1;
}

//ʾ8Ϊ壬ɫbc=ǰɫfcʱ͸ʾ
__attribute__((section(".highcode")))
void lcd_text_any(UINT16 x, UINT16 y, UINT8 w, UINT8 h, UINT16 fc, UINT16 bc, const UINT8 *s,UINT16 addr)
{
    UINT8 i,j,k,c;

    w=w/8;

    for(i=0;i<h;i++)
    for(j=0;j<w;j++)
        {
        c=*(s+addr*w*h+i*w+j);
        for (k=0;k<8;k++)   {

            if(c&(0x80>>k)) LCD_DrawPoint(x+j*8+k,y+i,fc);
            else {
                if (fc!=bc) LCD_DrawPoint(x+j*8+k,y+i,bc);
            }
        }
    }
}


//16ӢʾӦֿΪasc16,hzk16,λfont,hļ ɫbc=ǰɫfcʱ͸ʾ
__attribute__((section(".highcode")))
void lcd_text16(UINT16 x, UINT16 y, UINT16 fc, UINT16 bc,const UINT8 *s)
{
    UINT8 i,j;
    UINT16 k;
    CS0;
    while(*s) {
        if( *s < 0x80 ) {
            k=*s;
            if (k>32) k-=32; else k=0;

            for(i=0;i<16;i++)     {
                for(j=0;j<8;j++)
                    {
                        if(asc16[k*16+i]&(0x80>>j)) LCD_DrawPoint0(x+j,y+i,fc);
                        else {if (fc!=bc) LCD_DrawPoint0(x+j,y+i,bc);}
                    }
            }
            s++;x+=8;
            }
        else {

            for (k=0;k<hz16_num;k++) {
              if ((hz16[k].Index[0]==*(s))&&(hz16[k].Index[1]==*(s+1))){
                    for(i=0;i<16;i++)
                    {
                        for(j=0;j<16;j++)
                            {
                                if(hz16[k].Msk[i*2+(j/8)]&(0x80>>(j%8)))    LCD_DrawPoint0(x+j,y+i,fc);
                                else {
                                    if (fc!=bc) LCD_DrawPoint0(x+j,y+i,bc);
                                }
                            }
                    }
                }
            }
            s+=2;x+=16;
            }
        }
    CS1;
}

//24ӢʾӦֿΪasc24,hzk24,λfont,hļ ɫbc=ǰɫfcʱ͸ʾ
__attribute__((section(".highcode")))
void lcd_text24(UINT16 x, UINT16 y, UINT16 fc, UINT16 bc, UINT8 *s)
{
    UINT8 i,j;
    UINT16 k;

    CS0;

    while(*s) {
        if( *s < 0x80 ) {
            k=*s;
            if (k>32) k-=32; else k=0;

            for(i=0;i<24;i++)     {
                for(j=0;j<16;j++)
                    {
                        if(asc24[k*48+i*2+(j/8)]&(0x80>>(j%8))) LCD_DrawPoint0(x+j,y+i,fc);
                        else {if (fc!=bc) LCD_DrawPoint0(x+j,y+i,bc);}
                    }
            }
            s++;x+=12;
            }
        else {

            for (k=0;k<hz24_num;k++) {
              if ((hz24[k].Index[0]==*(s))&&(hz24[k].Index[1]==*(s+1))){
                    for(i=0;i<24;i++)
                    {
                        for(j=0;j<24;j++)
                            {
                                if(hz24[k].Msk[i*3+(j/8)]&(0x80>>(j%8)))    LCD_DrawPoint0(x+j,y+i,fc);
                                else {
                                    if (fc!=bc) LCD_DrawPoint0(x+j,y+i,bc);
                                }
                            }
                    }
                }
            }
            s+=2;x+=24;
            }
        }
    CS1;
}

void lb16(UINT16 x, UINT16 y, UINT16 fc, UINT8 *s) {
    lcd_text16(x+1,y+1,0,0,s);
    lcd_text16(x,y,fc,fc,s);
}

__attribute__((section(".highcode")))
void menu(void) {
    char tmp[10];
    UINT8 i,x,y;

    if ((pshow)||(m!=m0)) {
        if (m!=m0) {
           if (m<2) LCD_Fill(0,0,160,128,0);
           else {
               LCD_Fill(0,0,160,18,0);
               LCD_Fill(0,18,160,110,0x5AEB);
               lcd_text16(0,0,0xffff,0xffff,tt[m*2-1]);
           }
           pshow=1;
        }

        if (((m!=m0)||(medit))&&(m==4)) {
           sprintf(mt[0],"·: %s",(mset[0])?"":"ر");
           if (mset[1]==0) sprintf(mt[1],"Ŀ:  LC+HC");
           if (mset[1]==1) sprintf(mt[1],"Ŀ:  LC");
           if (mset[1]==2) sprintf(mt[1],"Ŀ:  HC");
           sprintf(mt[2],"©ѹ:  %5.2fV",0.01*mset[2]);
           sprintf(mt[3],"LCѹ:  %5.2fV",0.01*mset[3]);
           sprintf(mt[4],"LCѹ:  %5.2fV",0.01*mset[4]);
           sprintf(mt[5],"LC׼10uA:  %5.2fV",0.01*mset[5]);
           sprintf(mt[6],"LCʱ:  %ds",mset[6]);
           sprintf(mt[7],"HCѹ:  %5.2fV",0.01*mset[7]);
           sprintf(mt[8],"HCѹ:  %5.2fV",0.01*mset[8]);
           sprintf(mt[9],"HC׼10uA:  %5.2fV",0.01*mset[9]);
           sprintf(mt[10],"HCʱ:  %ds",mset[10]);
           sprintf(mt[11],"NGԶֹͣ: %s",(mset[11])?"":"ر");
       }
        m0=m;

        if (m==0){
            for (i=0;i<4;i++) {
                x=(i%2)*81;y=(i/2)*64;
                if (i==m2) {
                    LCD_Fill(x,y,79,62,0x7e0);
                    lcd_text24(x+26,y+5,0x0,0x0,tt[i*2]);
                    lcd_text16(x+22,y+34,0x0,0x0,tt[i*2+1]);
                } else {
                    LCD_Fill(x,y,79,62,0x39E7);
                    lcd_text24(x+26,y+5,0xffff,0xffff,tt[i*2]);
                    lcd_text16(x+22,y+34,0xffff,0xffff,tt[i*2+1]);
                }

            }
        }
        if (m==1) {
            LCD_Fill(0,0,79,18,0x41f);
            LCD_Fill(0,18,79,90,0x39E7);
            LCD_Fill(81,0,79,18,0xFC00);
            LCD_Fill(81,18,79,90,0x39E7);
            lcd_text16(32,1,0,0,"LC");
            lcd_text16(112,1,0,0,"HC");
            lcd_text16(1,110,0xffff,0xffff,"©:       :");
            for (i=0;i<10;i++) {
                lcd_text16((i/5)*81+1,(i%5)*18+18,0xffff,0xffff,tt[(i%5)+8]);
            }
        }

        if (m==4) {
           if (pshow==1) {
               for (i=0;i<6;i++) {
                   if (i==m2) {
                       LCD_Fill(0,18+i*18,160,18,(medit)?0xf800:0x7e0);
                       lcd_text16(2,19+i*18,0,0,mt[mi+i]);
                   } else {
                       LCD_Fill(0,18+i*18,160,18,0x5AEB);
                       lb16(2,19+i*18,0xffff,mt[mi+i]);
                   }
               }
           }
           if (pshow==2) {
               LCD_Fill(0,18+m20*18,160,18,0x5AEB);
               lb16(2,19+m20*18,0xffff,mt[mi+m20]);
               LCD_Fill(0,18+m2*18,160,18,(medit)?0xf800:0x7e0);
               lcd_text16(2,19+m2*18,0,0,mt[mi+m2]);
               m20=m2;
           }

        }
    }

    if (m==1) {
        for (i=0;i<5;i++) {
            if (i<4) {
                sprintf(tmp,"%5d",v[i]);
                lcd_text16(35,i*18+19,0xffff,0x39E7,tmp);
            } else {
                sprintf(tmp,"%3ds",v[4]);
                lcd_text16(45,i*18+19,0xffff,0x39E7,tmp);
            }
        }
        for (i=0;i<5;i++) {
            if (i<4) {
                sprintf(tmp,"%5d",v[i]);
                lcd_text16(116,i*18+19,0xffff,0x39E7,tmp);
            } else {
                sprintf(tmp,"%3ds",v[4]);
                lcd_text16(126,i*18+19,0xffff,0x39E7,tmp);
            }
        }
        lcd_text16(42,110,0x7e0,0x0,"0.65V");
        lcd_text16(140,110,0xf800,0x0,"NG");
    }

    pshow=0;

}

void menu2(void) {
    //ת
    if (kstep) {
        if (m==0) {
            if (kdir==1) {
                m2++;
                if (m2>3) m2=0;
            }
            if (kdir==2) {
               if (m2==0) m2=4;
               m2--;
            }
            kdir=0;
            pshow=1;
        }

        if (m==4) {
            if (kdir==1) {
                if (medit) {
                    if ((mi+m2)==0) mset[0]=1;
                    if ((mi+m2)==1) {if (mset[1]<2) mset[1]++;}

                    pshow=2;
                } else {
                    if (m2<5) {m2++;pshow=2;}
                    else {
                        if (mi<6) {mi++;pshow=1;}
                    }
                }
            }
            if (kdir==2) {
               if (medit) {
                   if ((mi+m2)==0) mset[0]=0;
                    if ((mi+m2)==1) {if (mset[1]) mset[1]--;}
                   pshow=2;
               } else {
                   if (m2) {m2--;pshow=2;}
                   else {
                       if (mi) {mi--;pshow=1;}
                   }
               }
            }
        }
    }
    kstep=0;

    //
    if (m==0) {
        if (key==1) {m=m2+1;m2=0;}
    } else {
        if (key==3) {m=0;mi=0;m2=0,medit=0;}
    }

    if (m==4) {
        if (key==1) {
            if (medit) medit=0; else medit=1;
            pshow=2;
        }
    }
}

int main()
{
  UINT8 i,xx=10;

  SetSysClock( CLK_SOURCE_PLL_60MHz );

  GPIOA_ModeCfg( GPIO_Pin_8, GPIO_ModeOut_PP_5mA);
  GPIOA_ModeCfg( GPIO_Pin_10, GPIO_ModeOut_PP_5mA);
  GPIOA_ModeCfg( GPIO_Pin_11, GPIO_ModeIN_Floating);
  GPIOA_ModeCfg( GPIO_Pin_12, GPIO_ModeIN_Floating);

  GPIOB_ModeCfg( GPIO_Pin_23, GPIO_ModeOut_PP_5mA );

  //LED
  DO=0X18;rushdo();

  //GET_UNIQUE_ID(id);

    //UART_init();

    GPIOA_ResetBits( GPIO_Pin_9 );            // PWM PA9
    GPIOA_ModeCfg( GPIO_Pin_9, GPIO_ModeOut_PP_5mA );
    TMR0_PWMInit( High_Level, PWM_Times_1 );
    TMR0_PWMCycleCfg( 3000 );        //  50us,20KHZ
    TMR0_Disable();
    TMR0_PWMActDataWidth(3000 );
    TMR0_Enable();

    TMR1_TimerInit( FREQ_SYS / 500 );                  // öʱʱ 2ms
    TMR1_ITCfg( ENABLE, TMR0_3_IT_CYC_END );          // ж
    PFIC_EnableIRQ( TMR1_IRQn );

    /* ͨѡadcͨ*/
    GPIOA_ModeCfg( GPIO_Pin_4, GPIO_ModeIN_Floating );
    GPIOA_ModeCfg( GPIO_Pin_5, GPIO_ModeIN_Floating );
    GPIOA_ModeCfg( GPIO_Pin_13, GPIO_ModeIN_Floating );
    GPIOA_ModeCfg( GPIO_Pin_14, GPIO_ModeIN_Floating );
    GPIOA_ModeCfg( GPIO_Pin_15, GPIO_ModeIN_Floating );

    //SPI0
    GPIOPinRemap(ENABLE,RB_PIN_SPI0);
    GPIOB_ModeCfg( GPIO_Pin_15, GPIO_ModeIN_Floating);

    GPIOB_SetBits( GPIO_Pin_12 );
    GPIOB_ModeCfg( GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14, GPIO_ModeOut_PP_5mA );
    SPI0_MasterDefInit();

    LCD_Init();

    //WWDG_SetCounter(0x0);
  //WWDG_ResetCfg(ENABLE);

  DO&=0Xc7;

  while(1) {
    // 0.2ˢ
    if (ss==0)  {
        ss=100;

        //WWDG_SetCounter(0x0);

        ADC_ExtSingleChSampInit( SampleFreq_3_2, ADC_PGA_0 );
        ADC_ChannelCfg(0);
        ad[0]=ADC_ExcutSingleConver();
        ADC_ChannelCfg(1);
        ad[1]=ADC_ExcutSingleConver();
        ADC_ChannelCfg(5);
        ad[2]=ADC_ExcutSingleConver();
        ADC_ChannelCfg(4);
        ad[3]=ADC_ExcutSingleConver();
        ADC_ChannelCfg(3);
        ad[4]=ADC_ExcutSingleConver();

        for(i=0;i<4;i++) v[i]=ad[i+1];
        v[4]+=2;

        //
        key=0;
        i=ad[0]/50;
        if ((i>62)&&(i<66)) key=1;
        if ((i>9)&&(i<13)) key=2;
        if ((i>44)&&(i<48)) key=3;

        menu2();
        menu();

        xx--;
        if (xx==0) {
            xx=10;

            DO|=0X8;

        } else DO&=0XF7;

        rushdo();
    }
  }
}

__attribute__((interrupt("WCH-Interrupt-fast")))
__attribute__((section(".highcode")))
void TMR1_IRQHandler( void )        // TMR0 ʱж
{
  if ( TMR1_GetITFlag( TMR0_3_IT_CYC_END ) )
  {
    TMR1_ClearITFlag( TMR0_3_IT_CYC_END );      // жϱ־

    if (ss) ss--;

    if (kdir==0) {
        if (KA==0) kdir=1;
        if (KB==0) kdir=2;
    } else {
        kdelay++;
        if (KA!=kstate) {
            kstate=KA;
            if (KA==0) kstep++;
            kdelay=0;
        }
        //ʱλ
        if (kdelay>100) {
            kdir=0;
            kdelay=0;
            kstate=0;
        }
    }
  }
}

__attribute__((interrupt("WCH-Interrupt-fast")))
__attribute__((section(".highcode")))
void UART1_IRQHandler( void )
{
  switch ( UART1_GetITFlag() )
  {
    case UART_II_LINE_STAT :        // ·״̬
    {
      //UART1_GetLinSTA();
      break;
    }

    case UART_II_RECV_RDY :          // ݴﵽô
      if (rin1<127) {
        rbuf1[rin1]=UART1_RecvByte();
        rin1++;
        rbuf1[rin1]=0;
      }
      break;

    case UART_II_RECV_TOUT :         // ճʱʱһ֡ݽ
      rin1 = UART1_RecvString(rbuf1 );
      break;

    case UART_II_THR_EMPTY :         // ͻգɼ
      break;

    default :
      break;
  }
}
